﻿<?php
if ( ! defined( 'ABSPATH' ) ) exit;

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       http://myworks.design/
 * @since      1.0.0
 *
 * @package    MW_QBO_Desktop
 * @subpackage MW_QBO_Desktop/admin/partials
 */
?>

<?php
	global $MWQDC_LB;
	$page_url = 'admin.php?page=mw-qbo-desktop-qwc-file';

	$error = array();
	if ( ! empty( $_POST['mw_qbo_dts_gen_qwc_file'] ) && check_admin_referer( 'myworks_wc_qb_dts_gen_qwc_file', 'mw_qbo_dts_gen_qwc_file' ) ) {
		$qwc_un = (isset($_POST['mw_qbo_dts_qwc_username']))?trim($_POST['mw_qbo_dts_qwc_username']):'';
		$qwc_pw = (isset($_POST['mw_qbo_dts_qwc_password']))?trim($_POST['mw_qbo_dts_qwc_password']):'';
		$qwc_ri= (isset($_POST['mw_qbo_dts_qwc_sec_interval']))?(int) $_POST['mw_qbo_dts_qwc_sec_interval']:0;
		if($qwc_ri < 60){
			$qwc_ri = 60;
		}
		if(strlen($qwc_un)<6){
			$error[] = 'QWC Username should be altleast 6 chars.';
		}
		if(strlen($qwc_pw)<8){
			$error[] = 'QWC Password should be altleast 8 chars.';
		}

		if(empty($error)){
			update_option('mw_qbo_dts_qwc_username',$qwc_un);
			update_option('mw_qbo_dts_qwc_password',$MWQDC_LB->encrypt($qwc_pw));
			update_option('mw_qbo_dts_qwc_sec_interval',$qwc_ri);
			
			//02-11-2017 - Need to update new password into quickbooks_user table
			$qb_hash_func = QUICKBOOKS_HASH;
			$qwc_pw_qb_enc = $qb_hash_func($qwc_pw . QUICKBOOKS_SALT);
			global $wpdb;
			$wpdb->update('quickbooks_user',array('qb_password'=>$qwc_pw_qb_enc),array('qb_username'=>$qwc_un),'',array('%s'));
			

			$MWQDC_LB->generate_qwc_file();
			//$MWQDC_LB->->redirect($page_url);
		}
	}

	$mw_qbo_dts_qwc_username = $MWQDC_LB->get_option('mw_qbo_dts_qwc_username');
	$mw_qbo_dts_qwc_password = $MWQDC_LB->get_option('mw_qbo_dts_qwc_password');

	$mw_qbo_dts_qwc_sec_interval = (int) $MWQDC_LB->get_option('mw_qbo_dts_qwc_sec_interval');
	if($mw_qbo_dts_qwc_sec_interval < 60){
		$mw_qbo_dts_qwc_sec_interval = 60;
		update_option('mw_qbo_dts_qwc_sec_interval',$mw_qbo_dts_qwc_sec_interval);
	}

	if($mw_qbo_dts_qwc_username==''){
		$mw_qbo_dts_qwc_username = $MWQDC_LB->get_random_username(6,10);
		update_option('mw_qbo_dts_qwc_username',$mw_qbo_dts_qwc_username);
	}

	if($mw_qbo_dts_qwc_password==''){
		$mw_qbo_dts_qwc_password = $MWQDC_LB->encrypt($MWQDC_LB->get_random_password(8,10));
		update_option('mw_qbo_dts_qwc_password',$mw_qbo_dts_qwc_password);
	}

	$mw_wc_qbo_sync_license = $MWQDC_LB->get_option('mw_wc_qbo_desk_license','');
	$mw_wc_qbo_sync_localkey = $MWQDC_LB->get_option('mw_wc_qbo_desk_localkey','');

?>

<!-- This file should primarily consist of HTML with a little bit of PHP. -->
<?php
echo '<form style="position:absolute; top:-100px;">
	  <label for="email">E-Mail</label>
	  <input id="email" readonly type="email" onfocus="if (this.hasAttribute(\'readonly\')) { this.removeAttribute(\'readonly\');
	    this.blur();    this.focus();  }" />
	  <label for="pw">Password</label>
	  <input id="pw" readonly type="password" onfocus="if (this.hasAttribute(\'readonly\')) { this.removeAttribute(\'readonly\');
	    this.blur();    this.focus();  }" />
	</form>
	';
	
?>
<div class="container qwc-outer">
<?php if($MWQDC_LB->is_valid_license($mw_wc_qbo_sync_license,$mw_wc_qbo_sync_localkey)):?>
<div class="mwqs_conection_options">
	<table class="widefat fixed">
		<tr>
			<td width="20%"><label for="mw_wc_qbo_sync_license_update_desk" class="mw_wc_qbo_sync_label">License Key:</label></td>
			<td  width="50%">
			<input class="mw_wc_qbo_sync_input" type="text" name="mw_wc_qbo_sync_license_update_desk" id="mw_wc_qbo_sync_license_update_desk" value="<?php echo $mw_wc_qbo_sync_license; ?>" required="required" disabled="disabled"/>
			&nbsp;<span class="mw_wc_qbo_sync_span"></span>
			</td>
			<td  width="30%">
				<p class="mw_wc_qbo_sync_paragraph">
				<?php
				echo __('To update your license key, deactivate and re-activate the plugin. All your settings and mappings will be saved.','mw_wc_qbo_sync');
				?>
				</p>
			</td>
		</tr>
	</table>

</div>
<div class="qwc-inner">
	<h2>Generate Quickbooks Web Connector (QWC) File</h2>
	<?php if(count($error)):?>
	<div style="color:red;"><?php echo implode('<br/>',$error);?></div>
	<?php endif;?>
	<form method="POST" action="<?php echo $page_url;?>">
		<table width="100%" class="qwc-tbl">
			<tr>
				<td>Create QWC Username(Min 6 chars): </td>
				<td>&nbsp;</td>
				<td>
					<input type="text" name="mw_qbo_dts_qwc_username" value="<?php echo $mw_qbo_dts_qwc_username;?>">
				</td>
			</tr>

			<tr>
				<td>Create QWC Password(Min 8 chars): </td>
				<td>&nbsp;</td>
				<td>
					<input type="password" name="mw_qbo_dts_qwc_password" id="mw_qbo_dts_qwc_password" value="<?php echo $MWQDC_LB->decrypt($mw_qbo_dts_qwc_password);?>"> &nbsp;
					<a href="javascript:void(0);" id="mw_qbo_dts_qwc_show_hide_pass">Show</a>
				</td>
			</tr>

			<tr>
				<td>Request Interval: </td>
				<td>&nbsp;</td>
				<td>
					<input type="text" size="5" name="mw_qbo_dts_qwc_sec_interval" value="<?php echo $mw_qbo_dts_qwc_sec_interval;?>">&nbsp;Default: 600 (in seconds)
				</td>
			</tr>

			<tr>
				<td>
					<?php wp_nonce_field( 'myworks_wc_qb_dts_gen_qwc_file', 'mw_qbo_dts_gen_qwc_file' ); ?>
					<input class="button button-primary button-large" type="submit" value="Save and Generate QWC File">
				</td>
				<td>&nbsp;</td>
				<td>
					<a target="_blank" href="https://marketplace.intuit.com/webconnector/" class="button button-primary button-large dwc_link">Download QuickBooks Web Connector</a>
				</td>
			</tr>

		</table>
	</form>
</div>

<?php	if($MWQDC_LB->is_qwc_connected()):	?>
	<div class="mwqd_cmp_info">
		<h2>QuickBooks Desktop Company Info</h2>
		<?php
			$mw_wc_qbo_desk_qbd_company_info_arr = $MWQDC_LB->get_option('mw_wc_qbo_desk_qbd_company_info_arr');
			if($mw_wc_qbo_desk_qbd_company_info_arr!=''){
				$mw_wc_qbo_desk_qbd_company_info_arr = unserialize($mw_wc_qbo_desk_qbd_company_info_arr);
			}
			if(is_array($mw_wc_qbo_desk_qbd_company_info_arr) && count($mw_wc_qbo_desk_qbd_company_info_arr)):
		?>
		<table class="wp-list-table widefat fixed striped posts">
			<tr>
				<td width="8%">Name:</td>
				<td><?php echo $mw_wc_qbo_desk_qbd_company_info_arr['CompanyName'];?></td>
			</tr>

			<tr>
				<td>Email:</td>
				<td><?php echo $mw_wc_qbo_desk_qbd_company_info_arr['Email'];?></td>
			</tr>

			<tr>
				<td>Country:</td>
				<td><?php echo $mw_wc_qbo_desk_qbd_company_info_arr['Country'];?></td>
			</tr>
		</table>
		<small>Showing based on last preferences import - <?php echo $mw_wc_qbo_desk_qbd_company_info_arr['added_date'];?></small>
		<?php else:?>
			<p>No company information found.</p>
		<?php endif;?>		
	</div>
<?php endif;?>

<?php elseif($MWQDC_LB->get_license_status()=='Invalid'):?>
<div class="qbd_input_license"><p><?php echo __('You have entered an invalid license key. Please enter a valid license key in order to use the plugin.','mw_wc_qbo_sync');?></p>
<?php elseif($MWQDC_LB->get_license_status()=='Expired'):?>
<div class="qbd_input_license"><p><?php echo __('Your license key is expired. Please renew your license with us or enter a valid license key in order to continue to use the plugin.','mw_wc_qbo_sync');?></p>
<?php elseif($MWQDC_LB->get_license_status()=='Suspended'):?>
<div class="qbd_input_license"><p><?php echo __('Your license key is suspended. Please contact us to unsuspend your license or enter a valid license key in order to continue to use the plugin.','mw_wc_qbo_sync');?></p>
<?php else:?>
<div class="qbd_input_license"><p><?php echo __('Please enter a valid license key in order to use the plugin.','mw_wc_qbo_sync');?></p>
<?php endif;?>

<?php if($MWQDC_LB->get_license_status()!='Active'):?>

<div class="mwqs_conection_license_check_desk">
<form method="post" id="myworks_wc_qbo_sync_check_license_desk">
	<label for ="mw_wc_qbo_sync_license_desk">License Key: </label>
	<input type="text" name="mw_wc_qbo_sync_license_desk" id="mw_wc_qbo_sync_license_desk" value="<?php echo $mw_wc_qbo_sync_license;?>">
	 <?php wp_nonce_field( 'myworks_wc_qbo_sync_check_license_desk', 'check_plugin_license_desk' ); ?>
	<input size="30" type="submit" value="Enter" class="button button-primary">
	<span id="mwqs_license_chk_loader" style="visibility:hidden;">
	<img src="<?php echo esc_url( plugins_url( 'image/ajax-loader.gif', dirname(__FILE__) ) );?>" alt="Loading..." />
	</span>
</form>
</div>
</div>

<?php endif;?>
</div>
<script>
	jQuery(document).ready(function($){
		$('#mw_qbo_dts_qwc_show_hide_pass').click(function(){
			$i_type = $('#mw_qbo_dts_qwc_password').attr('type');
			if($i_type=='password'){
				$('#mw_qbo_dts_qwc_password').attr('type','text');
				$(this).text('Hide');
			}else{
				$('#mw_qbo_dts_qwc_password').attr('type','password');
				$(this).text('Show');
			}
		});
	});
</script>
