<?php
if ( ! defined( 'ABSPATH' ) ) exit;

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       http://myworks.design/
 * @since      1.0.0
 *
 * @package    MW_QBO_Desktop
 * @subpackage MW_QBO_Desktop/admin/partials
 */
?>
<?php
global $MWQDC_LB;
global $wpdb;
$page_url = 'admin.php?page=mw-qbo-desktop-refresh-data';

if(isset($_POST['mw_wc_qbd_desk_settings']) && check_admin_referer( 'myworks_wc_qbd_sync_desktop_refresh_data', 'myworks_wc_qbd_sync_desktop_refresh_data' )){
	update_option('mw_wc_qbo_desk_cp_refresh_data_enable', isset($_POST['mw_wc_qbo_desk_cp_refresh_data_enable'])?$_POST['mw_wc_qbo_desk_cp_refresh_data_enable']:'');
	
	update_option('mw_wc_qbo_desk_cp_rf_data_options', isset($_POST['mw_wc_qbo_desk_cp_rf_data_options']) && is_array($_POST['mw_wc_qbo_desk_cp_rf_data_options']) && count($_POST['mw_wc_qbo_desk_cp_rf_data_options']) ? implode(',', $_POST['mw_wc_qbo_desk_cp_rf_data_options']) : '');
	update_option('mw_wc_qbo_desk_oth_refresh_data_enable', isset($_POST['mw_wc_qbo_desk_oth_refresh_data_enable'])?$_POST['mw_wc_qbo_desk_oth_refresh_data_enable']:'');
	
	update_option('mw_wc_qbo_desk_oth_rf_data_options', isset($_POST['mw_wc_qbo_desk_oth_rf_data_options']) && is_array($_POST['mw_wc_qbo_desk_oth_rf_data_options']) && count($_POST['mw_wc_qbo_desk_oth_rf_data_options']) ? implode(',', $_POST['mw_wc_qbo_desk_oth_rf_data_options']) : '');
	
	$MWQDC_LB->set_session_val('refresh_data_settings_update_message',__('Refresh data settings updated successfully.','mw_wc_qbo_desk'));
	$MWQDC_LB->redirect($page_url);
}
?>
<!-- This file should primarily consist of HTML with a little bit of PHP. -->
<?php echo $MWQDC_LB->get_admin_get_extra_css_js();?>
<?php echo $MWQDC_LB->get_checkbox_switch_css_js();?>
<div class="mw_wc_qbo_desk_container">
<form method="post">
<?php wp_nonce_field( 'myworks_wc_qbd_sync_desktop_refresh_data', 'myworks_wc_qbd_sync_desktop_refresh_data' ); ?>
<div class="container mwqbd" id="mw_qbo_sybc_settings_tables">
	<div class="card">
		<div class="card-content">
			<div class="row">
				<div class="col s12 m12 l12">
					<div class="row">
						<div class="col s12 m12 l12">
                         
							<div id="mw_qbo_sybc_settings_tab_wh_body">
							<h6><?php echo __('Refresh Data Settings For Next Request','mw_wc_qbo_desk') ?></h6>
							<table class="mw-qbo-sync-settings-table mwqs_setting_tab_body">
							<tbody>
								
								<tr>
									<th class="title-description">
								    	<?php echo __('Enable Refresh Data for Product/customer','mw_wc_qbo_desk') ?>
								    	
								    </th>
									<td>
										<div class="row">
											<div class="input-field col s12 m12 l12">
												<p>
													<input type="checkbox" class="filled-in mwqs_st_chk  production-option" name="mw_wc_qbo_desk_cp_refresh_data_enable" id="mw_wc_qbo_desk_cp_refresh_data_enable" value="true" <?php if(get_option('mw_wc_qbo_desk_cp_refresh_data_enable')=='true') echo 'checked' ?>>
												</p>
											</div>
										</div>
									</td>
									<td>
										<div class="material-icons tooltipped right tooltip"><?php echo __('?','mw_wc_qbo_desk') ?>
										  <span class="tooltiptext"><?php echo __('Check to enable Refresh Data into QuickBooks Desktop for next call.','mw_wc_qbo_desk') ?></span>
										</div>
									</td>
								</tr>
								
								<tr>
									<th class="title-description">
								    	<?php echo __('Data Types','mw_wc_qbo_desk') ?>
								    	
								    </th>
									<td>
										<div class="row">
											<div class="input-field col s12 m12 l12">
												<p>
													<?php $qbo_rt_import_items = array('customer' => 'Customer', 'product' => 'Product') ?>
													<?php if(is_array($qbo_rt_import_items) && count($qbo_rt_import_items)):?>
													<?php $rpi_val_arr = explode(',',get_option('mw_wc_qbo_desk_cp_rf_data_options'));?>
													<?php foreach($qbo_rt_import_items as $rpi_key => $rpi_val):?>
													<?php
														$rpi_checked = '';
														if(is_array($rpi_val_arr) && in_array($rpi_key,$rpi_val_arr)){
															$rpi_checked = ' checked="checked"';
														}
													?>
													
													<input type="checkbox" class="filled-in mwqs_st_chk  production-option" name="mw_wc_qbo_desk_cp_rf_data_options[]" id="mw_wc_qbo_desk_cp_rf_data_options_<?php echo $rpi_key;?>" value="<?php echo $rpi_key;?>" <?php echo $rpi_checked;?>>
													&nbsp;<span class="rt_item_hd"><?php echo $rpi_val;?></span>
													<br /><br />
													<?php endforeach;?>
													<?php endif;?>										            
												</p>
											</div>
										</div>
									</td>
									<td>
										<div class="material-icons tooltipped right tooltip"><?php echo __('?','mw_wc_qbo_desk') ?>
										  <span class="tooltiptext"><?php echo __('Choose sync items (you can choose multiple items).','mw_wc_qbo_desk') ?></span>
										</div>
									</td>
								</tr>

								<tr>
									<th class="title-description">
								    	<?php echo __('Enable Refresh Data for Other Types','mw_wc_qbo_desk') ?>
								    	
								    </th>
									<td>
										<div class="row">
											<div class="input-field col s12 m12 l12">
												<p>
													<input type="checkbox" class="filled-in mwqs_st_chk  production-option" name="mw_wc_qbo_desk_oth_refresh_data_enable" id="mw_wc_qbo_desk_oth_refresh_data_enable" value="true" <?php if(get_option('mw_wc_qbo_desk_oth_refresh_data_enable')=='true') echo 'checked' ?>>
												</p>
											</div>
										</div>
									</td>
									<td>
										<div class="material-icons tooltipped right tooltip"><?php echo __('?','mw_wc_qbo_desk') ?>
										  <span class="tooltiptext"><?php echo __('Check to enable Refresh Data into QuickBooks Desktop for next call.','mw_wc_qbo_desk') ?></span>
										</div>
									</td>
								</tr>
								
								<tr>
									<th class="title-description">
								    	<?php echo __('Other Data Types','mw_wc_qbo_desk') ?>
								    	
								    </th>
									<td>
										<div class="row">
											<div class="input-field col s12 m12 l12">
												<p>
													<?php $qbo_rt_import_items = array('account' => 'Account', 'class' => 'Class', 'payment_method' => 'Payment Method', 'sales_tax_code' => 'SalesTax Code', 'term' => 'Term', 'preferences' => 'Preferences') ?>
													
													<?php
														$qbo_rt_import_items['InventorySite'] = 'InventorySite';
														
														//$qbo_rt_import_items['OtherName'] = 'OtherName';
														$qbo_rt_import_items['SalesRep'] = 'SalesRep';
														
														$qbo_rt_import_items['CustomerType'] = 'CustomerType';
													?>
													
													<?php if(is_array($qbo_rt_import_items) && count($qbo_rt_import_items)):?>
													<?php $rpi_val_arr = explode(',',get_option('mw_wc_qbo_desk_oth_rf_data_options'));?>
													<?php foreach($qbo_rt_import_items as $rpi_key => $rpi_val):?>
													<?php
														$rpi_checked = '';
														if(is_array($rpi_val_arr) && in_array($rpi_key,$rpi_val_arr)){
															$rpi_checked = ' checked="checked"';
														}
													?>
													
													<input type="checkbox" class="filled-in mwqs_st_chk  production-option" name="mw_wc_qbo_desk_oth_rf_data_options[]" id="mw_wc_qbo_desk_oth_rf_data_options_<?php echo $rpi_key;?>" value="<?php echo $rpi_key;?>" <?php echo $rpi_checked;?>>
													&nbsp;<span class="rt_item_hd"><?php echo $rpi_val;?></span>
													<br /><br />
													<?php endforeach;?>
													<?php endif;?>										            
												</p>
											</div>
										</div>
									</td>
									<td>
										<div class="material-icons tooltipped right tooltip"><?php echo __('?','mw_wc_qbo_desk') ?>
										  <span class="tooltiptext"><?php echo __('Choose sync items (you can choose multiple items).','mw_wc_qbo_desk') ?></span>
										</div>
									</td>
								</tr>

            				</tbody>
							</table>
							</div>
							
							<div class="mw_wc_qbo_desk_clear"></div>
							<div class="row">
								<div class="input-field col s12 m6 l4">
									<input type="submit" name="mw_wc_qbd_desk_settings" id="mw_wc_qbd_desk_settings" class="waves-effect waves-light btn save-btn mw-qbo-sync-green" value="Save All">
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
</div>
</form>
</div>

<script >
	jQuery(document).ready(function(){
		jQuery('input.mwqs_st_chk').attr('data-size','small');
		jQuery('input.mwqs_st_chk').bootstrapSwitch();
	});
</script>

<?php
if($save_status = $MWQDC_LB->get_session_val('refresh_data_settings_update_message','',true)){
	$save_status = ($save_status!='')?$save_status:'error';
	$MWQDC_LB->set_admin_sweet_alert($save_status);
}
?>